#######################################################################
# arules - Mining Association Rules and Frequent Itemsets
# Copyright (C) 2011, 2012 Michael Hahsler, Christian Buchta, 
#			Bettina Gruen and Kurt Hornik
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.



##*******************************************************
## Function coverage
##
## return coverage (LHS support) for rules 

setMethod("coverage", signature(x = "rules"),
    function(x, transactions = NULL, reuse = TRUE) {
	q <- quality(x)

        if(reuse && all(c("support", "confidence") %in% names(q))) 
            return(q$support / q$confidence)
       
	if(is.null(transactions)) stop("transactions needed!")

        ## we need to calculate lhs-support    
        return(support(lhs(x), transactions))
    }
)

